clear all; close all; clc

% Number of cycles to run
cycles = 50;

% Pulse in the process setpoint
u = 0;
sp = 5;
dt = 1.0; % delta time
time = linspace(0,cycles*dt-dt,cycles); % time points

% Run cycles
for i = 1:cycles,
    % Display cycle
    disp(['Cycle: ' int2str(i)])
    
    %% Change setpoint
    if i==20,
        sp = 10;
    elseif i==40,
        sp = 0;
    end
    
    %% Process simulator
    measurement_noise = 0.1*(rand()-0.5);
    y_meas = process(u) + measurement_noise;
    
    %% Moving Horizon Estimator (MHE)
    [k_pred,tau_pred,y_pred] = mhe([y_meas,u]);
    
    %% Model Predictive Control (MPC)
    u = mpc([sp,y_meas,k_pred,tau_pred,y_pred]);
end
